	page	64,130
	Title ATCLOCK - Daily housekeeping.
;
;͸
;	Created 2 Jan. '88                                         
;	Date of last revision: 4 Jan. '88                          
;                                                                   
;  ATCLOCK.ASM                                                      
;                                                                   
;	Single segment '.COM' type program.                        
;	Description of function:  Checks for 1st time run today    
;	 from 'TODAY.AT' file. Nudges clock if so. Displays time   
;	 and date. Change nudge value by /Nxx command.             
;;
;
; Macros used for messages to stdout. Structure for date file.
; Uses .286 mode. Program is not re-entrant.
; Link with: ASMUTILS.LIB
;
INCLUDE	ASMUTILS.ASI
.SALL
DateInfo	STRUC
PDATE	DB	?
DOW	DB	?,?,?,?	; Today's date with month/day names.
DOM	DB	?,?,?	; Like " Sun 08 Jan 1989 "
MONTH	DB	?,?,?,?
CENTURY	DB	?,?
YEAR	DB	?,?,?
NewLine	DB	13,10	; CR, LF for message.
PDATNUMS	DB	6 DUP (?)	; Date in numbers. Like: "890108"
AscNudge	DB	5 DUP (?)
DateInfo	ENDS
.286
;
SEGZERO	SEGMENT  AT 0
	ORG	46CH	;Time info in BIOS' data area.
TimerLow	DW	?
TimerHigh	DW	?
SEGZERO	ENDS
;
CSEG	SEGMENT PARA PUBLIC 'CODE'
	ASSUME CS:CSEG,DS:CSEG
EXTRN	Asc2Bin:NEAR, SkipSpac:NEAR, AX4Digs:NEAR
EXTRN	MSG:NEAR, NDISPL:NEAR, EDISPL:NEAR, ProgName:NEAR
	ORG	100H
START:	JMP	PROG
NudgeVal	DW	0	;# ticks to nudge clock.
NewNudge	DB	0	;Flag for new nudge value command.
	PAGE
DOSDate	DateInfo <>
;	;Structure expansion edited out of listing.
TFDate	DateInfo <>
MsgSize	EQU	OFFSET DOSDate.PDATNUMS - OFFSET DOSDate
TFSiz	EQU	TYPE DOSDate	; Size of our data file. <Pg. 187>
CMOSCent	DB	19H
CMOSYear	DB	?
CMOSMon	DB	?
CMOSDay	DB	?
DAYS	DB	'Sun Mon Tue Wed Thu Fri Sat '
MOS	DB	'JanFebMarAprMayJunJulAugSepOctNovDec'
TimeDisp	DB	' '
TimeData	DB	?,?,':',?,?,':',?,?,13,10
TFName	DB	60 DUP (?)
TodayAT	DB	'TODAY.AT',0
	PAGE
PROG	PROC	NEAR
	CLD
;
;	;Check command line for /N command.
	MOV	SI,80H		;Read data from PSP 'till we get
	LODSB			;'/' or end of line.
	CMP	AL,02		;Must be 2 chars entered.
	JB	NoCmds
	CALL	SkipSpac	;Skip spaces after '/'.
ReadCmds:	LODSB
	CMP	AL,0DH
	JE	NoCmds
	CMP	AL,'/'
	JNE	ReadCmds
	LODSB
	CMP	AL,0DH
	JE	NoCmds
	AND	AL,0DFH		;Force upper case.
	CMP	AL,'N'		;If it's 'N', get a number.
	JNE	NoCmds
	CALL	SkipSpac	;Skip spaces after 'N'.
	MOV	CX,04		;Get up to four digits.
	CALL	Asc2Bin
	CMP	CX,04		;Did we get any digits?
	JE	NoCmds		;Branch if no.
;
	MOV	NudgeVal,AX	;Set new value and flag.
	MOV	NewNudge,0FFH
;
;	; Get the path to our directory.
NoCmds:	PUSH	DS		;Save our segment.
	CALL	ProgName	;Get path name to this prog in DS:SI.
	MOV	DI,OFFSET TFName ;Move path into name field for
	REP	MOVSB		  ; our data file.
	POP	DS			;Get our segment back and move in
	MOV	SI,OFFSET TodayAT	; filename after path.
	MOV	CX,9
	REP	MOVSB
	PAGE
; ; Get the date from DOS and set in our data area 3 different ways.
	MOV	DI,OFFSET DOSDate.PDATE
	MOV	AX,2A20H	;Put a space at beginning.
	STOSB			;Revise date string from start.
	INT	21H		;DOS Get date call.
	PUSH	CX		;Save year. AL has day-of-week.
; ;Day of week.
	MOV	SI,OFFSET DAYS
	XOR	AH,AH		;Multiply days x4 for offset
	ADD	SI,AX		; into table.
	CALL	SetDM		;Convert & store.
; ;Day of month.
	MOV	AL,DL		;Day of month in binary.
	CALL	ConvDig		;Convert & store.
	MOV	CMOSDay,AL	;Save for setting clock.
	MOV BYTE PTR [DI],' '		;Add a space.
	MOV AX,WORD PTR DosDate.DOM	;Put same value in numeric
	MOV WORD PTR DOSDate.PDATNUMS + 4,AX	;date.
; ;Month.
	MOV	AL,DH		;Get month number, 1-12 (not 0-11)
	MOV	DI,OFFSET DOSDate.PDATNUMS + 2 ; for variety.
	CALL	ConvDig		;Put in numeric date field.
	MOV	CMOSMon,AL	;Save for setting clock.
	MOV	AL,DH		;Adjust and put month name in.
	DEC	AL
	MOV	DI,OFFSET DOSDate.MONTH
	MOV	SI,OFFSET MOS	;Months calculated like days.
	CALL	SetDM
; ;Year.
	MOV	AX,'91'		;Put in '19'.
	POP	CX		;Get year.
	SUB	CX,1900
	CMP	CX,100
	JB	Twentieth
	MOV	CMOSCent,20H
	MOV	AX,'02'		;Change after 2000.
	SUB	CX,100
Twentieth: STOSW
	MOV	AL,CL		;Put year in AL.
	CALL	ConvDig
	MOV	CMOSYear,AL	;Save for setting clock.
	MOV BYTE PTR [DI],' '
	MOV	AX,[DI-2]	;Put year in numeric date.
	MOV WORD PTR DOSDate.PDATNUMS,AX
;
;	; Try to open the date file.
	MOV	DX,OFFSET TFName
	MOV	AX,3D02H	;Read/write access.
	INT	21H
	JC	RangeJmp	;Skip tests if no file.
	PAGE
;	; The file is open. Try to read it.
	MOV	BX,AX		;Handle to BX.
	MOV	CX,TFSiz 	;# bytes to CX.
	MOV	DX,OFFSET TFDate
	MOV	AH,3FH		;'Read from file or device'
	INT	21H
	JC	ReadErr		;Must have no DOS error and #bytes
	CMP	AX,CX		; read = # requested or file NG.
	JE	ReadOK
ReadErr:	MOV	AH,3EH		;Error on read. Close file, forget.
	INT	21H		;Ignore close errors.
RangeJmp:	JMP SHORT WrtToday
;
;	;File read OK. Compare the date with DOS' copy.
ReadOK:	MOV	AH,3EH		;Close file so we can re-write it.
	INT	21H
	MOV	SI,OFFSET DOSDate.PDATNUMS ;[SI]-DOS' numeric date.
	MOV	DI,OFFSET TFDate.PDATNUMS  ;[DI]-File's "       "
	MOV	CX,06			;6 digits.
	REPE	CMPSB			;Compare.
	JE	SameDay			;Like it says.
;
;	;New day. Get clock nudge value.
	TEST	NewNudge,0FFH		;Did we set new nudge value?
	JNZ	NudgeDOS		;Branch if yes.
	MOV	SI,OFFSET TFDate.AscNudge
	MOV	CX,04			;Convert 4 digits to binary.
	CALL	Asc2Bin
	MOV	NudgeVal,AX		;Save as current nudge value.
;
;	;Adjust the DOS clock first.
NudgeDOS:	MOV	AX,NudgeVal	;Get amount to adjust.
	TEST	AX,AX		;Skip this if it's zero.
	JZ	WrtToday
	XOR	BX,BX		;Get access to data area.
	MOV	DS,BX
	ASSUME  DS:SEGZERO	;Inform MASM.
	TEST	AH,80H		;Check for negative adjust.
	CLI			;Hold the clock off.
	JZ	PosAdj		;Branch if positive adjust.
	ADD	TimerLow,AX	;For negative, we get carry if
	JC	AdjDone		; result doesn't overflow.
	DEC	TimerHigh
	JMP SHORT AdjDone
PosAdj:	ADD	TimerLow,AX	;Adjust low word of timer data.
	JNC	AdjDone
	INC	TimerHigh
AdjDone: 	STI			;Time is adjusted in DOS.
	MOV	AX,CS		;Back to our segment.
	MOV	DS,AX
	ASSUME  DS:CSEG
	NRMessage <"Clock adjusted.">
	JMP SHORT WrtToday
;
;	;Same day. Rewrite file only if new nudge value.
SameDay:	TEST	NewNudge,0FFH
	JZ	Finish
	PAGE
;	;Clock twiddling done if needed. Write new date file.
WrtToday:	MOV	AX,NudgeVal	;Convert nudge value to ascii in
	MOV	DI,OFFSET DOSDate.AscNudge	;date info.
	CALL	AX4Digs
	MOV	DX,OFFSET TFName	;Create or overwrite 'Today'.
	XOR	CX,CX			;Normal, visible file.
	MOV	AH,3CH
	INT	21H
	JC	WritErr			;Bail out if error on create.
	MOV	BX,AX			;File handle to BX.
	MOV	CX,TFSiz		;# bytes to CX.
	MOV	DX,OFFSET DOSDate	;DX -> data to write.
	MOV	AH,40H			;'Write to file or device'.
	INT	21H
	JC	WritErr			;Bail on error.
	CMP	AX,CX			;Also if disk full <gasp>.
	JE	WriteOK
WritErr:	EMessage <"ATCLOCK: DOS error writing data file!">
WriteOK:	MOV	AH,3EH			;Close the file.
	INT	21H			;Ignore errors. Can't do anything.
;
;	;Set the CMOS clock from the DOS clock.
Finish:	MOV	AH,2CH		;Let DOS convert the raw ticks to
	INT	21H		; hr:min:sec.  We don't care if a
	CMP	DL,45		; tick went by.  Round off DOS'
	JB	NoRound		; ".01" seconds.
	INC	DH
;	;Change DOS time data to clock data format.
NoRound:	MOV	DI,OFFSET TimeData	;Point to time display data.
	MOV	AL,CH			;Convert hours for display and
	CALL	ConvDig			; to BCD for CMOS clock call.
	INC	DI			;Skip the colon.
	MOV	CH,AL
	MOV	AL,CL			;Same for minutes.
	CALL	ConvDig
	INC	DI			;Skip the colon.
	MOV	CL,AL
	MOV	AL,DH			;Same for seconds.
	CALL	ConvDig
	INC	DI			;Skip the colon.
	MOV	DH,AL
	XOR	DL,DL		;Set standard time.
	MOV	AH,03		; (Rev. 1.1 needed by April.)
	INT	1AH		;Set the CMOS clock.
;
;	;Set the CMOS clock date from our date from DOS.
	MOV	CH,CMOSCent		;Good for 112 more years...
	MOV	CL,CMOSYear
	MOV	DH,CMOSMon
	MOV	DL,CMOSDay
	MOV	AH,05
	INT	1AH		;Set the date.
	PAGE
;	;Display current date, time.
	MOV	DX,OFFSET DOSDate	;Write date to screen.
	MOV	CX,MsgSize
	CALL	MSG
	MOV	DX,OFFSET TimeDisp	;Write time to screen.
	MOV	CX,11			;11 characters.
	CALL	MSG
	RET				;End main program.
PROG	ENDP
;
;	; Update day or month data.
SetDM	PROC	NEAR
	XOR	AH,AH		;Mult. AL x3 for data address
	ADD	SI,AX		;in list. Move data to o/p area.
	SHL	AL,1
	ADD	SI,AX
	MOV	CX,03
	REP	MOVSB
	MOV	AL,' '
	STOSB			;Add space after data.
	RET
SetDM	ENDP
;
;	; Convert binary # in AL to 2-digit Ascii for display
;	; and packed BCD for CMOS clock set call. Uses BX.
ConvDig	PROC	NEAR
	AAM			;AL to unpacked BCD in AH,AL.
	MOV	BX,AX		;Save for further convert.
	OR	AX,3030H	;Change to Ascii.
	XCHG	AL,AH		;Change to Intel.
	STOSW			;Save for display.
	MOV	AL,BL		;Get LS nibble.
	SHL	BH,4		;OR in MS nibble.
	OR	AL,BH
	RET
ConvDig	ENDP
	DB	'Copyright (c) 1988, T. McGuire.'
CSEG	ENDS
	END	START
